VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00C0C0C0&
   Caption         =   "ADO OLEDB Sample"
   ClientHeight    =   5865
   ClientLeft      =   1770
   ClientTop       =   1665
   ClientWidth     =   8520
   LinkTopic       =   "Form1"
   ScaleHeight     =   5865
   ScaleWidth      =   8520
   Begin VB.TextBox txtQuery 
      Height          =   525
      Left            =   600
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   17
      Top             =   2400
      Width           =   7695
   End
   Begin VB.ListBox List2 
      Height          =   2400
      ItemData        =   "ado6.frx":0000
      Left            =   600
      List            =   "ado6.frx":0007
      TabIndex        =   16
      Top             =   3120
      Width           =   7695
   End
   Begin VB.Frame frmAuthorization 
      Height          =   1815
      Left            =   4560
      TabIndex        =   9
      Top             =   120
      Width           =   3855
      Begin VB.OptionButton optSSAuth 
         Caption         =   " SQL Server authentication"
         Height          =   252
         Left            =   240
         TabIndex        =   19
         Top             =   600
         Width           =   3252
      End
      Begin VB.OptionButton optWinNTAuth 
         Caption         =   "Windows NT authentication"
         Height          =   252
         Left            =   240
         TabIndex        =   18
         Top             =   240
         Width           =   2892
      End
      Begin VB.TextBox txtPassword 
         Height          =   288
         Left            =   1320
         TabIndex        =   13
         Top             =   1440
         Width           =   2292
      End
      Begin VB.TextBox txtUserName 
         Height          =   288
         Left            =   1320
         TabIndex        =   12
         Top             =   960
         Width           =   2292
      End
      Begin VB.Label lblPassword 
         Caption         =   "Password:"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   1440
         Width           =   975
      End
      Begin VB.Label lblUserName 
         Caption         =   "&Login name:"
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   960
         Width           =   975
      End
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "Execute"
      Height          =   372
      Left            =   2400
      TabIndex        =   8
      Top             =   1920
      Width           =   1452
   End
   Begin VB.Frame frmConnectionInfo 
      Height          =   1095
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   3732
      Begin VB.TextBox txtDatabaseName 
         Height          =   288
         Left            =   1200
         TabIndex        =   7
         Top             =   720
         Width           =   2172
      End
      Begin VB.TextBox txtServerName 
         Height          =   288
         Left            =   1200
         TabIndex        =   6
         Top             =   240
         Width           =   2172
      End
      Begin VB.Label Label2 
         Caption         =   "Database:"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   720
         Width           =   855
      End
      Begin VB.Label Label1 
         Caption         =   "SQL-Server"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   372
      Left            =   240
      TabIndex        =   2
      Top             =   1320
      Width           =   1455
   End
   Begin VB.CommandButton cmdDisconnect 
      Caption         =   "Disconnect"
      Height          =   372
      Left            =   240
      TabIndex        =   1
      Top             =   1920
      Width           =   1455
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   372
      Left            =   2400
      TabIndex        =   0
      Top             =   1320
      Width           =   1455
   End
   Begin VB.Label lblQueryResults 
      Caption         =   "Results:"
      Height          =   255
      Left            =   0
      TabIndex        =   15
      Top             =   3120
      Width           =   615
   End
   Begin VB.Label lblQueryEntry 
      Caption         =   "Select"
      Height          =   255
      Left            =   0
      TabIndex        =   14
      Top             =   2520
      Width           =   495
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuItemExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAboutItem 
         Caption         =   "&ADO Sample"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim cn As New ADODB.Connection
Dim Msg As String
Dim cmd As String
Dim Response As String
Dim errcase As Integer
Const Title = "Server Connection"
Const MsgConnSucc = "Connection to server successful."
Const MsgConnUn = "No server connection."
Private Sub Form_Load()
    buttonsConnectClosed
    optWinNTAuth.Value = True
    WinNTAuthOptionsOn
End Sub
Private Sub Form_Unload(Cancel As Integer)
    If cn.State = adStateOpen Then
      cn.Close
    End If
    End
End Sub
Private Sub cmdConnect_Click()
    ' Connect to server through SQL Server OLE DB Provider.
    Dim ServerName As String
    Dim DatabaseName As String
    Dim UserName As String
    Dim Password As String
    On Error GoTo ErrorConnect:
    ' Clear the error log display.
    Form2.lstErrors.Clear
   ' Put text box values into connection variables.
     ServerName = txtServerName.Text
     DatabaseName = txtDatabaseName.Text
     UserName = txtUserName.Text
     Password = txtPassword.Text
     ' Set connection properties.
    cn.ConnectionTimeout = 25
    cn.Provider = "INTERSOLV Sybase OLE DB Provider"
   'cn.Provider = "INTERSOLV Oracle8 OLE DB Provider"
   'cn.Provider = "INTERSOLV Informix7 OLE DB Provider"
   'cn.Provider = "SQLOLEDB"
    cn.Properties("Data Source").Value = ServerName
    cn.Properties("Initial Catalog").Value = DatabaseName
   ' Decision code for login authorization type: WinNT or SQL Server.
    If optWinNTAuth.Value = True Then
        cn.Properties("Integrated Security").Value = "SSPI"
    Else
        cn.Properties("User ID").Value = UserName
        cn.Properties("Password").Value = Password
    End If
    
    ' Change mousepointer while trying to open database.
    Screen.MousePointer = vbHourglass
    
    ' Open the database.
    cn.Open
    
    ' Change mousepointer back to the default after open.
    Screen.MousePointer = vbDefault
    
    ' Notify user that connection was successful.
    Response = MsgBox(MsgConnSucc, vbOKOnly, Title)
    
    ' Enable buttons for performing queries; disable others.
    buttonsConnectOpen
    
    Exit Sub
   
ErrorConnect:
    
    ' Error checking. Connection successful.
    If cn.State = adStateOpen Then
        errcase = 1
    End If
    
    ' Error checking. Connection unsuccessful.
    If cn.State <> adStateOpen Then
        errcase = 2
    End If
    
    ' Go to general error-logging routine.
    ErrorLog
 
 End Sub

Private Sub cmdDisconnect_Click()
     
    ' Clear the error log display.
    Form2.lstErrors.Clear
        ' Disconnect from a connected server.
    If cn.State = adStateOpen Then
        Msg = "Disconnect from Server?"
        Response = MsgBox(Msg, vbOKCancel, Title)
        If Response = vbOK Then
            cn.Close
            List2.Clear
            txtQuery.Text = ""
            buttonsConnectClosed
        Else
            txtQuery.SetFocus
        End If
    End If
   
End Sub

Private Sub cmdExecute_Click()
        Dim rs As ADODB.Recordset
    Dim fldLoop As ADODB.Field
        Dim rowstring As String, boolvalue As Boolean, _
       rowvalue As String, rowcount As Integer
        On Error GoTo ErrorExecute
     'Clear the results displays (error log and results).
    Form2.lstErrors.Clear
    List2.Clear
                   
    ' Change mousepointer to busy.
    Screen.MousePointer = vbHourglass
    
    ' Put SQL query text into variable cmd1.
    cmd = txtQuery.Text
    ' Initialize recordset
    Set rs = New ADODB.Recordset
    
     'Open recordset.
    rs.Open cmd, cn
       
    ' Move to first row.
    rs.MoveFirst
   
        Do Until rs Is Nothing
        
        For Each fldLoop In rs.Fields
            rowvalue = fldLoop.Name
            rowstring = rowstring + rowvalue
            Next fldLoop
               
        List2.AddItem rowstring
        List2.AddItem ""
            
        Do While Not rs.EOF
                
            With rs
            
                rowvalue = ""
                rowstring = ""
                            
                ' Concatenate column values for each record.
                For Each fldLoop In rs.Fields
               
                    ' Catch ADO Boolean type values, convert to VB string.
                   If fldLoop.Type = adBoolean Then
                       boolvalue = fldLoop.Value
                       rowvalue = CStr(boolvalue)
                     'Catch NULL values, convert to string "NULL" for display.
                    ElseIf IsNull(fldLoop.Value) = True Then
                        rowvalue = "NULL"
                    Else
                        rowvalue = fldLoop.Value
                    End If
                
                    rowstring = rowstring + rowvalue
                    
                    'rowstring = rowstring + rowvalue + padding
                Next fldLoop      ' End of inner loop.
                
                List2.AddItem rowstring
                rowstring = ""
            End With
            rowcount = rowcount + 1
            rs.MoveNext
        Loop                    ' End of outer loop.
    
        ' Display summary data on query results
        List2.AddItem "intcount" = 1
   
        List2.AddItem ""
        rowcount = 0
        
           
        Set rs = rs.NextRecordset
        
    Loop        ' End outermost (multiple result sets) loop.
    
    buttonsQueryDone
    
     'Change mousepointer to normal.
    Screen.MousePointer = vbDefault
    
    Exit Sub
      

ErrorExecute:
    
    ' Error checking. Bad query.
    
    If cn.State = adStateOpen Then
        errcase = 3
    End If
    
    ErrorLog
    
End Sub

Private Sub ErrorLog()
    
    Dim errLoop As ADODB.Error
    
    ' Change mousepointer to normal.
    Screen.MousePointer = vbDefault

    Select Case errcase
            
        ' 1 = successful connection; if a non-provider error occurred, which
        '     can't be saved in the ADO Errors collection, error processing
        '     ends. If a provider error occurred, processing continues.
        Case 1, 2, 3
            If errcase = 1 Then
                If cn.Errors.Count = 0 Then
                    Exit Sub
                End If
            End If
            
        ' 2 = Notify user of no connection. Then go on to error logging.
            If errcase = 2 Then
                Response = MsgBox(MsgConnUn, vbOKOnly, Title)
            End If
        
        ' 3 = Error occurred during the attempt to execute or
        '       execution of the query.
            If errcase = 3 Then
                If cn.Errors.Count = 0 Then
                    Exit Sub
                End If
            End If
        
        ' Create each error message in the errors list box.
        ' Each string in the list box corresponds to an ADO Error property.
                
        ' Array items correspond to a set of properties for each
        '   ADO Error object.
        ' The HelpFile and HelpContext properties are not exposed.
          
             For Each errLoop In cn.Errors
                
                Dim strError(5)
                Dim i As Integer
               
                strError(0) = "Error Number: " & errLoop.Number
                strError(1) = "  Description: " & errLoop.Description
                strError(2) = "  Source: " & errLoop.Source
                strError(3) = "  SQL State: " & errLoop.SQLState
                strError(4) = "  Native Error: " & errLoop.NativeError
                
                ' Loop through first five properties of Error object.
                i = 0
                Do While i < 5
                    Form2.lstErrors.AddItem strError(i)
                    i = i + 1
                Loop
                
                ' Add a blank line after each error message.
                Form2.lstErrors.AddItem ""
            
            Next    ' Continue looping through ADO Errors collection.
            
            'Display a count of the provider errors.
            'Form2.lstErrors.AddItem c
            Form2.lstErrors.AddItem ""
            Form2.Show
            
            ' Clear the ADO errors collection.
            cn.Errors.Clear
        
        Case Else          ' Fall-through case statement.
            Exit Sub
    
    End Select
    
End Sub

Private Sub cmdClear_Click()
    ' Clear the query and query results boxes.
    txtQuery.Text = ""
    List2.Clear
    txtQuery.SetFocus
End Sub

Private Sub mnuAboutItem_Click()
    FormAbout.Show
End Sub
Private Sub mnuItemExit_Click()
    If cn.State = adStateOpen Then
      cn.Close
    End If
    End
End Sub

Private Sub optSSAuth_Click()
    If optSSAuth.Value = True Then
        SSAuthOptionsOn
    End If
End Sub
Private Sub optWinNTAuth_Click()
    optWinNTAuth.Value = True
    WinNTAuthOptionsOn
    txtUserName.Text = ""
    txtPassword.Text = ""
End Sub
Private Sub buttonsConnectClosed()
    cmdConnect.Enabled = True
    cmdConnect.Default = True
    cmdDisconnect.Enabled = False
    cmdExecute.Enabled = False
    cmdClear.Enabled = False
End Sub

Private Sub buttonsConnectOpen()
    cmdConnect.Enabled = False
    cmdDisconnect.Enabled = True
    cmdExecute.Enabled = True
    cmdClear.Enabled = False
End Sub
Private Sub buttonsQueryDone()
    cmdConnect.Enabled = False
    cmdDisconnect.Enabled = True
    cmdExecute.Enabled = True
    cmdClear.Enabled = True
End Sub
Private Sub WinNTAuthOptionsOn()
    lblUserName.Enabled = False
    lblPassword.Enabled = False
    txtUserName.Enabled = False
    txtPassword.Enabled = False
End Sub
Private Sub SSAuthOptionsOn()
    lblUserName.Enabled = True
    lblPassword.Enabled = True
    txtUserName.Enabled = True
    txtPassword.Enabled = True
End Sub

